package com.maraujo

import scala.collection.mutable
import scala.collection.mutable.ArrayBuffer

class Factor(A: ArrayBuffer[Double], B: ArrayBuffer[Double], C: ArrayBuffer[Double]) {
  val Asorted = A.zipWithIndex.sortBy(-_._1)
  val Bsorted = B.zipWithIndex.sortBy(-_._1)
  val Csorted = C.zipWithIndex.sortBy(-_._1)

  val nextA = mutable.PriorityQueue.empty[(Double, (Int, Int, Int))]
  // initialize priorityqueue
  for (i <- B.indices)
    for (j <- C.indices) {
      nextA += ((Asorted(0)._1 * Bsorted(i)._1 * Csorted(j)._1, (0, i, j)))
    }

  // remove front value (v, (i, j, k)), add value (v2, (i+1, j, k))
  def updateStatus() : Unit = {
    val best = nextA.dequeue()
    nextA += ((Asorted(best._2._1+1)._1 * Bsorted(best._2._2)._1 * Csorted(best._2._3)._1, (best._2._1+1, best._2._2, best._2._3)))
  }


  def nextNonZero() : (Double, (Int, Int, Int)) = {
    val top = nextA.head
    val ret = (top._1, (Asorted(top._2._1)._2, Bsorted(top._2._2)._2, Csorted(top._2._3)._2))

    updateStatus()

    ret
  }

  def getScore(p: (Int, Int, Int)) : Double = A(p._1)*B(p._2)*C(p._3)

  def getFrontValue : Double = nextA.head._1
}
